/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.Agreement;

private import appstream.AgreementSection;
private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.PtrArray;
private import glib.Str;
private import glib.c.functions;
private import gobject.ObjectG;


/** */
public class Agreement : ObjectG
{
	/** the main Gtk struct */
	protected AsAgreement* asAgreement;

	/** Get the main Gtk struct */
	public AsAgreement* getAgreementStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asAgreement;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asAgreement;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsAgreement* asAgreement, bool ownedRef = false)
	{
		this.asAgreement = asAgreement;
		super(cast(GObject*)asAgreement, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_agreement_get_type();
	}

	/**
	 * Creates a new #AsAgreement.
	 *
	 * Returns: a #AsAgreement
	 *
	 * Since: 0.12.1
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_agreement_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsAgreement*) __p, true);
	}

	/** */
	public void addSection(AgreementSection agreementSection)
	{
		as_agreement_add_section(asAgreement, (agreementSection is null) ? null : agreementSection.getAgreementSectionStruct());
	}

	/**
	 * Gets the agreement kind.
	 *
	 * Returns: a string, e.g. %AS_AGREEMENT_KIND_EULA
	 *
	 * Since: 0.12.1
	 */
	public AsAgreementKind getKind()
	{
		return as_agreement_get_kind(asAgreement);
	}

	/**
	 * Gets the first section in the agreement.
	 *
	 * Returns: agreement section, or %NULL
	 *
	 * Since: 0.12.1
	 */
	public AgreementSection getSectionDefault()
	{
		auto __p = as_agreement_get_section_default(asAgreement);

		if(__p is null)
		{
			return null;
		}

		return ObjectG.getDObject!(AgreementSection)(cast(AsAgreementSection*) __p);
	}

	/**
	 * Gets all the sections in the agreement.
	 *
	 * Returns: array
	 *
	 * Since: 0.12.1
	 */
	public PtrArray getSections()
	{
		auto __p = as_agreement_get_sections(asAgreement);

		if(__p is null)
		{
			return null;
		}

		return new PtrArray(cast(GPtrArray*) __p);
	}

	/**
	 * Gets the agreement version_id.
	 *
	 * Returns: a string, e.g. "1.4a", or NULL
	 *
	 * Since: 0.12.1
	 */
	public string getVersionId()
	{
		return Str.toString(as_agreement_get_version_id(asAgreement));
	}

	/**
	 * Sets the agreement kind.
	 *
	 * Params:
	 *     kind = the agreement kind, e.g. %AS_AGREEMENT_KIND_EULA
	 *
	 * Since: 0.12.1
	 */
	public void setKind(AsAgreementKind kind)
	{
		as_agreement_set_kind(asAgreement, kind);
	}

	/**
	 * Sets the agreement version identifier.
	 *
	 * Params:
	 *     versionId = the agreement version ID, e.g. "1.4a"
	 *
	 * Since: 0.12.1
	 */
	public void setVersionId(string versionId)
	{
		as_agreement_set_version_id(asAgreement, Str.toStringz(versionId));
	}
}
