/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.ComponentBox;

private import appstream.Component;
private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.ErrorG;
private import glib.GException;
private import glib.PtrArray;
private import gobject.ObjectG;


/** */
public class ComponentBox : ObjectG
{
	/** the main Gtk struct */
	protected AsComponentBox* asComponentBox;

	/** Get the main Gtk struct */
	public AsComponentBox* getComponentBoxStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asComponentBox;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asComponentBox;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsComponentBox* asComponentBox, bool ownedRef = false)
	{
		this.asComponentBox = asComponentBox;
		super(cast(GObject*)asComponentBox, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_component_box_get_type();
	}

	/**
	 * Creates a new #AsComponentBox.
	 *
	 * Returns: an #AsComponentBox
	 *
	 * Since: 1.0
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this(AsComponentBoxFlags flags)
	{
		auto __p = as_component_box_new(flags);

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsComponentBox*) __p, true);
	}

	/**
	 * Creates a new #AsComponentBox with the simplest parameters,
	 * so it is basically an array storage without overhead.
	 *
	 * Only the most basic checks on inserted components will be performed,
	 * and it is assumed that the inserted components have been checked
	 * already prior to insertion.
	 *
	 * Returns: an #AsComponentBox
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_component_box_new_simple();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new_simple");
		}

		this(cast(AsComponentBox*) __p, true);
	}

	/**
	 * Add a component to the box. Returns an error if we could not add it
	 * (most likely due to component box constraints).
	 *
	 * Returns: %TRUE on success.
	 *
	 * Throws: GException on failure.
	 */
	public bool add(Component cpt)
	{
		GError* err = null;

		auto __p = as_component_box_add(asComponentBox, (cpt is null) ? null : cpt.getComponentStruct(), &err) != 0;

		if (err !is null)
		{
			throw new GException( new ErrorG(err) );
		}

		return __p;
	}

	/**
	 * Get the contents of this component box as #GPtrArray.
	 *
	 * Returns: an array of #AsComponent instances.
	 */
	public PtrArray asArray()
	{
		auto __p = as_component_box_as_array(asComponentBox);

		if(__p is null)
		{
			return null;
		}

		return new PtrArray(cast(GPtrArray*) __p);
	}

	/**
	 * Remove all contents of this component box.
	 */
	public void clear()
	{
		as_component_box_clear(asComponentBox);
	}

	/**
	 * Get the flags this component box was constructed with.
	 *
	 * Returns: The #AsComponentBoxFlags that are in effect.
	 */
	public AsComponentBoxFlags getFlags()
	{
		return as_component_box_get_flags(asComponentBox);
	}

	/**
	 * Get the amount of components in this box.
	 *
	 * Returns: Amount of components.
	 */
	public uint getSize()
	{
		return as_component_box_get_size(asComponentBox);
	}

	/**
	 * Retrieve a component at the respective index from the internal
	 * component array.
	 *
	 * Params:
	 *     index = The component index.
	 *
	 * Returns: An #AsComponent or %NULL
	 */
	public Component indexSafe(uint index)
	{
		auto __p = as_component_box_index_safe(asComponentBox, index);

		if(__p is null)
		{
			return null;
		}

		return ObjectG.getDObject!(Component)(cast(AsComponent*) __p);
	}

	/**
	 * Check if there are any components present.
	 *
	 * Returns: %TRUE if this component box is empty.
	 */
	public bool isEmpty()
	{
		return as_component_box_is_empty(asComponentBox) != 0;
	}

	/**
	 * Remove a component at the specified index.
	 * Please ensure that the index is not larger than
	 * %as_component_box_get_size() - 1
	 *
	 * Params:
	 *     index = the index of the component to remove.
	 */
	public void removeAt(uint index)
	{
		as_component_box_remove_at(asComponentBox, index);
	}

	/**
	 * Sort components to bring them into a deterministic order.
	 */
	public void sort()
	{
		as_component_box_sort(asComponentBox);
	}

	/**
	 * Sort components by their (search) match score.
	 */
	public void sortByScore()
	{
		as_component_box_sort_by_score(asComponentBox);
	}
}
