/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.Developer;

private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.Str;
private import glib.c.functions;
private import gobject.ObjectG;


/** */
public class Developer : ObjectG
{
	/** the main Gtk struct */
	protected AsDeveloper* asDeveloper;

	/** Get the main Gtk struct */
	public AsDeveloper* getDeveloperStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asDeveloper;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asDeveloper;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsDeveloper* asDeveloper, bool ownedRef = false)
	{
		this.asDeveloper = asDeveloper;
		super(cast(GObject*)asDeveloper, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_developer_get_type();
	}

	/**
	 * Creates a new #AsDeveloper.
	 *
	 * Returns: a #AsDeveloper
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_developer_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsDeveloper*) __p, true);
	}

	/**
	 * Gets a unique ID for this particular developer, e.g. "gnome" or "mozilla.org"
	 *
	 * Returns: the unique developer ID, or %NULL if none was set.
	 */
	public string getId()
	{
		return Str.toString(as_developer_get_id(asDeveloper));
	}

	/**
	 * Get a localized developer, or development team name.
	 *
	 * Returns: the developer name.
	 */
	public string getName()
	{
		return Str.toString(as_developer_get_name(asDeveloper));
	}

	/**
	 * Sets the unique ID of this developer.
	 *
	 * Params:
	 *     id = a developer ID, e.g. "mozilla.org"
	 */
	public void setId(string id)
	{
		as_developer_set_id(asDeveloper, Str.toStringz(id));
	}

	/**
	 * Set the the developer or development team name.
	 *
	 * Params:
	 *     value = the developer or developer team name
	 *     locale = the BCP47 locale, or %NULL. e.g. "en-GB"
	 */
	public void setName(string value, string locale)
	{
		as_developer_set_name(asDeveloper, Str.toStringz(value), Str.toStringz(locale));
	}
}
