/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.Reference;

private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.Str;
private import glib.c.functions;
private import gobject.ObjectG;


/** */
public class Reference : ObjectG
{
	/** the main Gtk struct */
	protected AsReference* asReference;

	/** Get the main Gtk struct */
	public AsReference* getReferenceStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asReference;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asReference;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsReference* asReference, bool ownedRef = false)
	{
		this.asReference = asReference;
		super(cast(GObject*)asReference, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_reference_get_type();
	}

	/**
	 * Creates a new #AsReference.
	 *
	 * Returns: a #AsReference
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_reference_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsReference*) __p, true);
	}

	/**
	 * Gets the reference kind.
	 *
	 * Returns: the #AsReferenceKind
	 *
	 * Since: 1.0.0
	 */
	public AsReferenceKind getKind()
	{
		return as_reference_get_kind(asReference);
	}

	/**
	 * Gets the name of the registry this reference is for,
	 * if the reference is of type %AS_REFERENCE_KIND_REGISTRY.
	 * Otherwise return %NULL.
	 *
	 * Returns: the registry name.
	 */
	public string getRegistryName()
	{
		return Str.toString(as_reference_get_registry_name(asReference));
	}

	/**
	 * Gets the value of this reference, e.g. a DOI if the
	 * reference kind is %AS_REFERENCE_KIND_DOI or an URL
	 * for %AS_REFERENCE_KIND_CITATION_CFF.
	 *
	 * Returns: the value of this reference.
	 */
	public string getValue()
	{
		return Str.toString(as_reference_get_value(asReference));
	}

	/**
	 * Sets the reference kind.
	 *
	 * Params:
	 *     kind = the #AsReferenceKind, e.g. %AS_REFERENCE_KIND_DOI.
	 *
	 * Since: 1.0.0
	 */
	public void setKind(AsReferenceKind kind)
	{
		as_reference_set_kind(asReference, kind);
	}

	/**
	 * Sets a name of a registry if this reference is of
	 * type %AS_REFERENCE_KIND_REGISTRY.
	 *
	 * Params:
	 *     name = name of an external registry.
	 */
	public void setRegistryName(string name)
	{
		as_reference_set_registry_name(asReference, Str.toStringz(name));
	}

	/**
	 * Sets a value for this reference.
	 *
	 * Params:
	 *     value = a value for this reference, e.g. "10.1000/182"
	 */
	public void setValue(string value)
	{
		as_reference_set_value(asReference, Str.toStringz(value));
	}
}
