/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.Relation;

private import appstream.Pool;
private import appstream.RelationCheckResult;
private import appstream.SystemInfo;
private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.ErrorG;
private import glib.GException;
private import glib.PtrArray;
private import glib.Str;
private import glib.c.functions;
private import gobject.ObjectG;


/** */
public class Relation : ObjectG
{
	/** the main Gtk struct */
	protected AsRelation* asRelation;

	/** Get the main Gtk struct */
	public AsRelation* getRelationStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asRelation;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asRelation;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsRelation* asRelation, bool ownedRef = false)
	{
		this.asRelation = asRelation;
		super(cast(GObject*)asRelation, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_relation_get_type();
	}

	/**
	 * Creates a new #AsRelation.
	 *
	 * Returns: a #AsRelation
	 *
	 * Since: 0.11.0
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_relation_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsRelation*) __p, true);
	}

	/**
	 * Calculate a compatibility sore between 0 and 100 based on the given set of
	 * AsRelationCheckResults.
	 *
	 * A compatibility of 100 means all requirements are satisfied and the component will
	 * run perfectly on the confoguration it was tested agains, while 0 means it will not run at all.
	 *
	 * Params:
	 *     rcResults = an array of #AsRelationCheckResult
	 */
	public static int checkResultsGetCompatibilityScore(PtrArray rcResults)
	{
		return as_relation_check_results_get_compatibility_score((rcResults is null) ? null : rcResults.getPtrArrayStruct());
	}

	/**
	 * The version comparison type.
	 *
	 * Returns: an enum of type #AsRelationCompare
	 *
	 * Since: 0.12.0
	 */
	public AsRelationCompare getCompare()
	{
		return as_relation_get_compare(asRelation);
	}

	/**
	 * Gets the display side kind, in case this item is of
	 * kind %AS_RELATION_ITEM_KIND_DISPLAY_LENGTH
	 *
	 * Returns: a #AsDisplaySideKind or %AS_DISPLAY_SIDE_KIND_UNKNOWN
	 *
	 * Since: 0.12.12
	 */
	public AsDisplaySideKind getDisplaySideKind()
	{
		return as_relation_get_display_side_kind(asRelation);
	}

	/**
	 * The kind of the item of this #AsRelation.
	 *
	 * Returns: an enum of type #AsRelationItemKind
	 *
	 * Since: 0.12.0
	 */
	public AsRelationItemKind getItemKind()
	{
		return as_relation_get_item_kind(asRelation);
	}

	/**
	 * The type (and thereby strength) of this #AsRelation.
	 *
	 * Returns: an enum of type #AsRelationKind
	 *
	 * Since: 0.12.0
	 */
	public AsRelationKind getKind()
	{
		return as_relation_get_kind(asRelation);
	}

	/**
	 * Get the value of this #AsRelation item as #AsControlKind if the
	 * type of this relation is %AS_RELATION_ITEM_KIND_CONTROL.
	 * Otherwise return %AS_CONTROL_KIND_UNKNOWN
	 *
	 * Returns: a #AsControlKind or %AS_CONTROL_KIND_UNKNOWN in case the item is not of the right kind.
	 *
	 * Since: 0.12.11
	 */
	public AsControlKind getValueControlKind()
	{
		return as_relation_get_value_control_kind(asRelation);
	}

	/**
	 * Returns: The value of this #AsRelation item as an integer. Returns 0 if the value was no integer.
	 *
	 * Since: 0.12.0
	 */
	public int getValueInt()
	{
		return as_relation_get_value_int(asRelation);
	}

	/**
	 * If this #AsRelation is of kind %AS_RELATION_ITEM_KIND_INTERNET, return the
	 * minimum bandwidth requirement of the component, if set.
	 *
	 * If the relation is of a different kind, or the requirement isn’t set, this
	 * returns `0`.
	 *
	 * Returns: The minimum bandwidth requirement, in Mbit/s.
	 *
	 * Since: 0.15.5
	 */
	public uint getValueInternetBandwidth()
	{
		return as_relation_get_value_internet_bandwidth(asRelation);
	}

	/**
	 * Get the value of this #AsRelation item as #AsInternetKind if the
	 * type of this relation is %AS_RELATION_ITEM_KIND_INTERNET.
	 * Otherwise return %AS_INTERNET_KIND_UNKNOWN
	 *
	 * Returns: a #AsInternetKind or %AS_INTERNET_KIND_UNKNOWN in case the item is not of the right kind.
	 *
	 * Since: 0.15.5
	 */
	public AsInternetKind getValueInternetKind()
	{
		return as_relation_get_value_internet_kind(asRelation);
	}

	/**
	 * In case this #AsRelation is of kind %AS_RELATION_ITEM_KIND_DISPLAY_LENGTH,
	 * return the set logical pixel amount.
	 *
	 * Returns: The logical pixel amount for this display length, value <= 0 on error.
	 *
	 * Since: 0.12.12
	 */
	public int getValuePx()
	{
		return as_relation_get_value_px(asRelation);
	}

	/**
	 * Returns: The value of the item this #AsRelation is about, as a string.
	 *
	 * Since: 0.12.12
	 */
	public string getValueStr()
	{
		return Str.toString(as_relation_get_value_str(asRelation));
	}

	/**
	 * Returns: The version of the item this #AsRelation is about.
	 *
	 * Since: 0.12.0
	 */
	public string getVersion()
	{
		return Str.toString(as_relation_get_version(asRelation));
	}

	/**
	 * Test if this relation is satisfied on the current system or with the
	 * provided #AsPool. If no #AsSystemInfo is found, a temporary one will be
	 * created. If no #AsPool is provided, any component relationships can not
	 * be validated and an error will be thrown.
	 *
	 * Params:
	 *     systemInfo = an #AsSystemInfo to use for system information.
	 *     pool = an #AsPool to find component dependencies in.
	 *
	 * Returns: an #AsRelationCheckResult with details about the result, or %NULL on error.
	 *
	 * Throws: GException on failure.
	 */
	public RelationCheckResult isSatisfied(SystemInfo systemInfo, Pool pool)
	{
		GError* err = null;

		auto __p = as_relation_is_satisfied(asRelation, (systemInfo is null) ? null : systemInfo.getSystemInfoStruct(), (pool is null) ? null : pool.getPoolStruct(), &err);

		if (err !is null)
		{
			throw new GException( new ErrorG(err) );
		}

		if(__p is null)
		{
			return null;
		}

		return ObjectG.getDObject!(RelationCheckResult)(cast(AsRelationCheckResult*) __p, true);
	}

	/**
	 * Set the version comparison type of this #AsRelation.
	 *
	 * Params:
	 *     compare = the new #AsRelationCompare
	 *
	 * Since: 0.12.0
	 */
	public void setCompare(AsRelationCompare compare)
	{
		as_relation_set_compare(asRelation, compare);
	}

	/**
	 * Sets the display side kind, in case this item is of
	 * kind %AS_RELATION_ITEM_KIND_DISPLAY_LENGTH
	 *
	 * Params:
	 *     kind = the new #AsDisplaySideKind.
	 *
	 * Since: 0.12.12
	 */
	public void setDisplaySideKind(AsDisplaySideKind kind)
	{
		as_relation_set_display_side_kind(asRelation, kind);
	}

	/**
	 * Set the kind of the item this #AsRelation is about.
	 *
	 * Params:
	 *     kind = the new #AsRelationItemKind
	 *
	 * Since: 0.12.0
	 */
	public void setItemKind(AsRelationItemKind kind)
	{
		as_relation_set_item_kind(asRelation, kind);
	}

	/**
	 * Set the kind of this #AsRelation.
	 *
	 * Params:
	 *     kind = the new #AsRelationKind
	 *
	 * Since: 0.12.0
	 */
	public void setKind(AsRelationKind kind)
	{
		as_relation_set_kind(asRelation, kind);
	}

	/**
	 * Set relation item value from an #AsControlKind.
	 *
	 * Params:
	 *     kind = an #AsControlKind
	 *
	 * Since: 0.12.12
	 */
	public void setValueControlKind(AsControlKind kind)
	{
		as_relation_set_value_control_kind(asRelation, kind);
	}

	/**
	 * Sets the item value as an integer, if the given item type
	 * of this #AsRelation permits integer values.
	 *
	 * Params:
	 *     value = the new value.
	 *
	 * Since: 0.12.12
	 */
	public void setValueInt(int value)
	{
		as_relation_set_value_int(asRelation, value);
	}

	/** */
	public void setValueInternetBandwidth(uint bandwidthMbitps)
	{
		as_relation_set_value_internet_bandwidth(asRelation, bandwidthMbitps);
	}

	/**
	 * Set relation item value from an #AsInternetKind.
	 *
	 * Params:
	 *     kind = an #AsInternetKind
	 *
	 * Since: 0.15.5
	 */
	public void setValueInternetKind(AsInternetKind kind)
	{
		as_relation_set_value_internet_kind(asRelation, kind);
	}

	/**
	 * Sets the item value as logical pixel count. This requires the relation
	 * to be of item kind %AS_RELATION_ITEM_KIND_DISPLAY_LENGTH.
	 *
	 * Params:
	 *     logicalPx = logical pixel count.
	 *
	 * Since: 0.12.12
	 */
	public void setValuePx(int logicalPx)
	{
		as_relation_set_value_px(asRelation, logicalPx);
	}

	/**
	 * Sets the item value as a string, if the given item type
	 * of this #AsRelation permits string values.
	 *
	 * Params:
	 *     value = the new value.
	 *
	 * Since: 0.12.12
	 */
	public void setValueStr(string value)
	{
		as_relation_set_value_str(asRelation, Str.toStringz(value));
	}

	/**
	 * Sets the item version.
	 *
	 * Params:
	 *     version_ = the new version.
	 *
	 * Since: 0.12.0
	 */
	public void setVersion(string version_)
	{
		as_relation_set_version(asRelation, Str.toStringz(version_));
	}

	/**
	 * Tests whether the version number of this #AsRelation is fulfilled by
	 * @version. Whether the given version is sufficient to fulfill the version
	 * requirement of this #AsRelation is determined by its comparison resraint.
	 *
	 * Params:
	 *     version_ = a version number, e.g. `1.2.0`
	 *
	 * Returns: %TRUE if the version from the parameter is sufficient.
	 *
	 * Since: 0.12.0
	 *
	 * Throws: GException on failure.
	 */
	public bool versionCompare(string version_)
	{
		GError* err = null;

		auto __p = as_relation_version_compare(asRelation, Str.toStringz(version_), &err) != 0;

		if (err !is null)
		{
			throw new GException( new ErrorG(err) );
		}

		return __p;
	}
}
