/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module ascompose.c.types;

public import appstream.c.types;
public import gdkpixbuf.c.types;
public import gio.c.types;
public import glib.c.types;
public import gobject.c.types;

public import glib.c.types;
public import gobject.c.types;
public import gio.c.types;
public import appstream.c.types;
public import gdkpixbuf.c.types;

public import core.stdc.stdio;
public import core.stdc.string;

/**
 * A drawing error.
 */
public enum AscCanvasError
{
	/**
	 * Generic failure.
	 */
	FAILED = 0,
	/**
	 * Drawing operation failed.
	 */
	DRAWING = 1,
	/**
	 * Issue with font or font selection.
	 */
	FONT = 2,
	/**
	 * The requested action was not supported.
	 */
	UNSUPPORTED = 3,
}
alias AscCanvasError CanvasError;

/**
 * A metadata composition error.
 */
public enum AscComposeError
{
	/**
	 * Generic failure.
	 */
	FAILED = 0,
}
alias AscComposeError ComposeError;

public enum AscComposeFlags
{
	NONE = 0,
	USE_THREADS = 1,
	ALLOW_NET = 2,
	VALIDATE = 4,
	STORE_SCREENSHOTS = 8,
	ALLOW_SCREENCASTS = 16,
	PROCESS_FONTS = 32,
	PROCESS_TRANSLATIONS = 64,
	IGNORE_ICONS = 128,
	PROCESS_UNPAIRED_DESKTOP = 256,
	PROPAGATE_CUSTOM = 512,
	PROPAGATE_ARTIFACTS = 1024,
	NO_FINAL_CHECK = 2048,
	NO_PARTIAL_URLS = 4096,
}
alias AscComposeFlags ComposeFlags;

/**
 * Designated state for an icon of a given size.
 */
public enum AscIconState
{
	/**
	 * Ignore icons of this size.
	 */
	IGNORED = 0,
	/**
	 * Create cache for the icon, and provide remote link as well.
	 */
	CACHED_REMOTE = 1,
	/**
	 * Set if the icon should be stored in an icon tarball and be cached locally.
	 */
	CACHED_ONLY = 2,
	/**
	 * Set if this icon should be stored remotely and fetched on demand.
	 */
	REMOTE_ONLY = 3,
}
alias AscIconState IconState;

/**
 * An image processing error.
 */
public enum AscImageError
{
	/**
	 * Generic failure.
	 */
	FAILED = 0,
	/**
	 * The graphic type is not supported.
	 */
	UNSUPPORTED = 1,
}
alias AscImageError ImageError;

/**
 * File format of an image.
 */
public enum AscImageFormat
{
	/**
	 * Unknown image format.
	 */
	UNKNOWN = 0,
	/**
	 * PNG format
	 */
	PNG = 1,
	/**
	 * JPEG format
	 */
	JPEG = 2,
	/**
	 * GIF format
	 */
	GIF = 3,
	/**
	 * SVG format
	 */
	SVG = 4,
	/**
	 * Compressed SVG format
	 */
	SVGZ = 5,
	/**
	 * WebP format
	 */
	WEBP = 6,
	/**
	 * AVIF format
	 */
	AVIF = 7,
	/**
	 * XPM format
	 */
	XPM = 8,
}
alias AscImageFormat ImageFormat;

/**
 * The flags used for loading images.
 */
public enum AscImageLoadFlags
{
	/**
	 * No special flags set
	 */
	NONE = 0,
	/**
	 * Sharpen the resulting image
	 */
	SHARPEN = 1,
	/**
	 * Allow loading of unsupported image types.
	 */
	ALLOW_UNSUPPORTED = 2,
	/**
	 * Always resize the source image to the perfect size
	 */
	ALWAYS_RESIZE = 4,
}
alias AscImageLoadFlags ImageLoadFlags;

/**
 * The flags used for saving images.
 */
public enum AscImageSaveFlags
{
	/**
	 * No special flags set
	 */
	NONE = 0,
	/**
	 * Optimize generated PNG for size
	 */
	OPTIMIZE = 1,
	/**
	 * Pad with alpha to 16:9 aspect
	 */
	PAD_16_9 = 2,
	/**
	 * Sharpen the image to clarify detail
	 */
	SHARPEN = 4,
	/**
	 * Blur the image to clear detail
	 */
	BLUR = 8,
}
alias AscImageSaveFlags ImageSaveFlags;

struct AscCanvas;

struct AscCanvasClass
{
	GObjectClass parentClass;
}

struct AscCompose
{
	GObject parentInstance;
}

struct AscComposeClass
{
	GObjectClass parentClass;
	/** */
	extern(C) void function() AsReserved1;
	/** */
	extern(C) void function() AsReserved2;
	/** */
	extern(C) void function() AsReserved3;
	/** */
	extern(C) void function() AsReserved4;
}

struct AscDirectoryUnit
{
	AscUnit parentInstance;
}

struct AscDirectoryUnitClass
{
	AscUnitClass parentClass;
	/** */
	extern(C) void function() AsReserved1;
	/** */
	extern(C) void function() AsReserved2;
	/** */
	extern(C) void function() AsReserved3;
	/** */
	extern(C) void function() AsReserved4;
}

struct AscHint
{
	GObject parentInstance;
}

struct AscHintClass
{
	GObjectClass parentClass;
	/** */
	extern(C) void function() AsReserved1;
	/** */
	extern(C) void function() AsReserved2;
	/** */
	extern(C) void function() AsReserved3;
	/** */
	extern(C) void function() AsReserved4;
}

struct AscIconPolicy
{
	GObject parentInstance;
}

struct AscIconPolicyClass
{
	GObjectClass parentClass;
	/** */
	extern(C) void function() AsReserved1;
	/** */
	extern(C) void function() AsReserved2;
	/** */
	extern(C) void function() AsReserved3;
	/** */
	extern(C) void function() AsReserved4;
}

struct AscIconPolicyIter
{
	void* dummy1;
	uint dummy2;
	void* dummy3;
	void* dummy4;
	void* dummy5;
	void* dummy6;
}

struct AscImage;

struct AscImageClass
{
	GObjectClass parentClass;
}

struct AscResult
{
	GObject parentInstance;
}

struct AscResultClass
{
	GObjectClass parentClass;
	/** */
	extern(C) void function() AsReserved1;
	/** */
	extern(C) void function() AsReserved2;
	/** */
	extern(C) void function() AsReserved3;
	/** */
	extern(C) void function() AsReserved4;
}

struct AscUnit
{
	GObject parentInstance;
}

struct AscUnitClass
{
	GObjectClass parentClass;
	/** */
	extern(C) int function(AscUnit* unit, GError** err) open;
	/** */
	extern(C) void function(AscUnit* unit) close;
	/** */
	extern(C) int function(AscUnit* unit, const(char)* filename) fileExists;
	/** */
	extern(C) int function(AscUnit* unit, const(char)* dirname) dirExists;
	/** */
	extern(C) GBytes* function(AscUnit* unit, const(char)* filename, GError** err) readData;
	/** */
	extern(C) void function() AsReserved1;
	/** */
	extern(C) void function() AsReserved2;
	/** */
	extern(C) void function() AsReserved3;
	/** */
	extern(C) void function() AsReserved4;
}

/**
 * Function which is called after all metainfo and related data (e.g. desktop-entry files)
 * has been loaded, but *before* any expensive operations such as screenshot downloads or
 * font searches are performed.
 *
 * This function can be useful to filter out unwanted components early in the process and
 * avoid unneeded downloads and other data processing.
 * By the time this function is called, the component's global ID should be finalized
 * and should not change any longer.
 *
 * Please note that this function may be called from any thread, and thread safety needs
 * to be taked care off by the callee.
 *
 * Params:
 *     cres = A pointer to generated #AscResult
 *     unit = The unit we are currently processing.
 *     userData = Additional data.
 */
public alias extern(C) void function(AscResult* cres, AscUnit* unit, void* userData) AscCheckMetadataEarlyFn;

/**
 * Function which is called while parsing a desktop-entry file to allow external
 * translations of string values. This is used in e.g. the Ubuntu distribution.
 *
 * The return value must contain a list of strings with the locale name in even indices,
 * and the text translated to the preceding locale in the following odd indices.
 *
 * Params:
 *     de = A pointer to the desktop-entry data we are reading.
 *     text = The string to translate.
 *     userData = Additional data.
 *
 * Returns: A new #GPtrArray containing the translation mapping.
 */
public alias extern(C) GPtrArray* function(GKeyFile* de, const(char)* text, void* userData) AscTranslateDesktopTextFn;
